unit Baumout;

interface

uses extctrls, BinBaum;

procedure BaumAnzeigen(b: TBinbaum; PB: TPaintBox);

implementation

procedure BaumAnzeigen(b: TBinbaum; PB: TPaintBox);
var Ebenen: integer;
    Hoehe_pro_Ebene: integer;

  function pot(a,b: integer): integer;
    begin
    result:= 1;
    while (b>0) do begin result:= result*a; dec(b); end;
  end;

  function Baumhoehe(b: TBinBaum): integer;
  var h1, h2: integer;
  begin
    if b.leer
      then Baumhoehe:= 0
      else begin
             h1:= Baumhoehe(b.LinkerTeilbaum);
             h2:= Baumhoehe(b.RechterTeilbaum);
             if h1 > h2
                then Baumhoehe:= h1+1
                else Baumhoehe:= h2+1;
           end;
  end;

  procedure ZeigeWurzelMitTeilbaeumen(b: TBinbaum; PB: TPaintBox; x,y: integer);
  var tb: TBinbaum;
      Breite: integer;
  begin
    if (not b.Leer)
    then begin
           if y>0 then
             PB.Canvas.LineTo(x,y*Hoehe_pro_Ebene);
           PB.Canvas.TextOut(x-PB.Canvas.TextWidth(b.WurzelinhaltToString) div 2,y*Hoehe_pro_Ebene,b.WurzelinhaltToString);
           PB.Canvas.MoveTo(x,y*Hoehe_pro_Ebene+PB.Canvas.TextHeight(b.WurzelinhaltToString));
           tb:= b.LinkerTeilbaum;
           ZeigeWurzelMitTeilbaeumen(tb, PB, x-PB.Width div pot(2,y+2), y+1);
           PB.Canvas.MoveTo(x,y*Hoehe_pro_Ebene+PB.Canvas.TextHeight(b.WurzelinhaltToString));
           tb:= b.RechterTeilbaum;
           ZeigeWurzelMitTeilbaeumen(tb, PB, x+PB.Width div pot(2,y+2), y+1);
         end;
  end;


begin
  PB.Refresh;
  Ebenen:= Baumhoehe(b);
  if Ebenen > 0
  then begin
         Hoehe_pro_Ebene:= PB.Height div Ebenen;
         ZeigeWurzelMitTeilbaeumen(b, PB, pb.Width div 2, 0);
       end;
end;

end.
