unit Io;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, BaumOut, IntBaum, ExtCtrls, StdCtrls;

type
  TF_Baum = class(TForm)
    MM_Baum: TMainMenu;
    MI_Datei: TMenuItem;
    MI_Beenden: TMenuItem;
    MI_Trenner_Datei1: TMenuItem;
    MI_Neu: TMenuItem;
    PB_Baum: TPaintBox;
    M_Ausgabe: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Teste1: TMenuItem;
    Hhe1: TMenuItem;
    Elementanzahl1: TMenuItem;
    Blattanzahl1: TMenuItem;
    Suchbaum1: TMenuItem;
    AVLBaum1: TMenuItem;
    procedure MI_BeendenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MI_NeuClick(Sender: TObject);
    procedure Hhe1Click(Sender: TObject);
    procedure Elementanzahl1Click(Sender: TObject);
    procedure Blattanzahl1Click(Sender: TObject);
    procedure Suchbaum1Click(Sender: TObject);
    procedure AVLBaum1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    Baum: TIntBinBaum;
  public
    { Public-Deklarationen }
  end;

var
  F_Baum: TF_Baum;

implementation

{$R *.DFM}


procedure TF_Baum.MI_BeendenClick(Sender: TObject);
begin
  Close;
end;

procedure TF_Baum.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Baum.Free;
end;

procedure TF_Baum.MI_NeuClick(Sender: TObject);
var s: string;
begin
  Baum.Free;
  Baum:= NIL;
  s:= '5,3,1,#,2,#,#,4,#,#,8,7,6,#,#,#,9,#,#';
  if InputQuery ('PreOrder-Eingabe','Baum in PreOrder-Notation eingeben. Leere Teilbume mit # kennzeichnen',s)
  then begin
         Baum:= VonPreOrder(s);
       end;
  BaumAnzeigen(Baum,PB_Baum);
  BaumInMemo(Baum,M_Ausgabe);
end;

procedure TF_Baum.Hhe1Click(Sender: TObject);
begin
  ShowMessage(IntToStr(Baumhoehe(Baum)));
end;

procedure TF_Baum.Elementanzahl1Click(Sender: TObject);
begin
  ShowMessage(IntToStr(KnotenAnzahl(Baum)));
end;

procedure TF_Baum.Blattanzahl1Click(Sender: TObject);
begin
  ShowMessage(IntToStr(BlattAnzahl(Baum)));
end;

procedure TF_Baum.Suchbaum1Click(Sender: TObject);
begin
  if IstSuchbaum(Baum)
    then ShowMessage('JA, ist ein Suchbaum')
    else ShowMessage('NEIN, ist kein Suchbaum');
end;

procedure TF_Baum.AVLBaum1Click(Sender: TObject);
begin
  if IstAVLBaum(Baum)
    then ShowMessage('JA, ist ein AVL-Baum')
    else ShowMessage('NEIN, ist kein AVL-Baum');
end;

end.
